/********
Animator Class
*********/
#ifndef __ANIMATOR_H__
#define __ANIMATOR_H__

#include "texture.h"
#include "material.h"
#include "model.h"
#include "tinyxml.h"
#include "frame.h"
#include "particle.h"
#include <vector>

class pModel;
class Frame;

class Animator {
public:
	Animator();
	~Animator();

	bool loadScene( TiXmlDocument* doc );
	void loadScene();
	void loadFrames( TiXmlElement* element );
	void render( int t, bool rt );
	void addTexture( pTexture * tex );
	void addMaterial( pMaterial * mat );
	void addModel( pModel * obj );
	void addFrame( Frame * frame );
	void addParticle( ParticleSystem * ps );
	pTexture *getTexture( const char * name );
	pMaterial *getMaterial( const char * name );
	pModel *getModel( const char * name );
	int getLength() { return length; }

private:

	vector<pMaterial *> materials;
	vector<pModel *> models;
	vector<pTexture *> textures;
	vector<Frame *> frames;
	vector<ParticleSystem *> psystem;
	Frame * currFrame;
	int length;
};

#endif 
