/********
Frame Class
*********/
#include "frame.h"

ModelFrame::ModelFrame( pModel * o ): 
obj(o),rotx(0),roty(0),rotz(0) 
{}

ModelFrame::~ModelFrame(){
}

Frame::Frame( int t ): tick(t) {
	next = NULL;
}

Frame::~Frame(){
	while( !objs.empty() ) {
		ModelFrame* obj = objs.back();
		objs.pop_back();
		delete obj;
	}
}

void Frame::addModelFrame( ModelFrame* mf ) {
	objs.push_back( mf );
}

ModelFrame *Frame::getModelFrame( pModel* obj ) {
	for( unsigned int i = 0; i < objs.size(); i++ ) {
		if( objs[i]->getModel() == obj ) {
			return objs[i];
		}
	}
	return NULL;
}

void Frame::setNextFrame( Frame * frame) {
	next = frame;
}

void Frame::render( int t, bool rt ) {
	for( unsigned int i = 0; i < objs.size(); i++ ) {
		Point3D pos;
		double x, y, z;
		ModelFrame * start = objs[i];
		if( next == NULL ) {
			pos = start->getPos();
			x = start->getRX();
			y = start->getRY();
			z = start->getRZ();
		} else {
			ModelFrame * dst = next->getModelFrame( start->getModel() );
			if( dst == NULL ) continue;
			unsigned int tdiff = next->getTime() - tick;
			unsigned int time = t - tick;
			double ratio = (double)time/tdiff;
			pos = start->getPos() + ratio * ( dst->getPos() - start->getPos() );
			x = start->getRX() + ratio * ( dst->getRX() - start->getRX() );
			y = start->getRY() + ratio * ( dst->getRY() - start->getRY() );
			z = start->getRZ() + ratio * ( dst->getRZ() - start->getRZ() );
		}
		glPushMatrix();
		glTranslated( pos[0], pos[1], pos[2] );
		glRotated( x, 1, 0, 0);
		glRotated( y, 0, 1, 0);
		glRotated( z, 0, 0, 1);
		start->getModel()->render( rt );
		glPopMatrix();
	}
}
