/********
Frame Class
*********/
#ifndef __FRAME_H__
#define __FRAME_H__

#include "util.h"
#include "model.h"
#include "algebra.h"

class Frame;

class ModelFrame {
public:
	ModelFrame( pModel * o );
	~ModelFrame();
	void setPos( Point3D &p ) { pos = p; };
	void setRX( double r ) { rotx = r; };
	void setRY( double r ) { roty = r; };
	void setRZ( double r ) { rotz = r; };
	Point3D getPos() { return pos; };
	double getRX() { return rotx; };
	double getRY() { return roty; };
	double getRZ() { return rotz; };
	pModel *getModel() { return obj; };

private:
	pModel * obj;
	Point3D pos;
	double rotx;
	double roty;
	double rotz;
};

class Frame {
public:
	Frame( int t );
	~Frame();
	void render( int t, bool rt );
	int getTime() { return tick; };
	void addModelFrame( ModelFrame* mf );
	void setNextFrame( Frame * );
	Frame * getNextFrame() const { return next; };
	ModelFrame* getModelFrame( pModel*obj );
private:
	int tick;
	Frame *next;
	vector< ModelFrame* > objs;
};

#endif
