/********
Material Class
*********/
#ifndef __MATERIAL_H__
#define __MATERIAL_H__

#include "texture.h"
#include "algebra.h"
#include <string>

using namespace std;

class pMaterial {
public:
	pMaterial( const char *mname );
	pMaterial( const char *mname, rgb d );
	pMaterial( const char *mname, rgb d, rgb s );
	void setDiffuse( rgb d );
	void setSpecular( rgb s );
	void setTexture( int n, ptrTexture tex );
	int numTextures();
	void renderColour( );
	void renderTextureCube( Point3D &pmin, Point3D &pmax, int num, double s, double t, double r );
	void renderTexture( Point3D &pmin, Point3D &pmax, int num, double s, double t, double r, int axis );
	void clearRender();
	~pMaterial();
	const string& getname() const;

private:
	void inittextures();
	void renderTex( GLdouble *s, GLdouble *t );
	void getPlane( int num, GLdouble *ps, GLdouble *pt, Point3D &pmin, Point3D &pmax, GLdouble s, GLdouble t, GLdouble r);
	rgb diffuse;
	rgb specular;
	ptrTexture* textures;
	string name;
};

#endif
