/********
Model Class
*********/
#ifndef __MODEL_H__
#define __MODEL_H__

#include "material.h"
#include "algebra.h"
#include <vector>
#include <string>

using namespace std;

class Animator;

class FaceRef {
public:
	FaceRef( int pri, int face ) {
		p = pri;
		f = face;
	};
	~FaceRef(){};
	int p;
	int f;
};

class PrioritizeFaces { 
public: 
	int operator()( const FaceRef &a, const FaceRef &b ) 
	{ return a.p > b.p; };
};

class pModel {
public:
	pModel( const char *mname );
    ~pModel();
	bool loadOBJ( const char *objname );
	void setMaterial( pMaterial *mat );
	void setAxis( int a );
	void setTMap( Point3D p );
	void genDrawList( bool smooth );
	void render( bool rt);
	const string& getname() const;

private:
	bool readOBJ( const char *objname  );

	GLuint drawlist;
	pMaterial *m;
	vector<Point3D> v;	
	vector< vector<int>* > f;
	string name;
	int taxis;
	Vector3D axis;
	Point3D tmap;

};
#endif
