/***************
Summed Area Table Class
*****************/
#ifndef __SAT_H__
#define __SAT_H__

#include "util.h"

class SAT {
public:
	SAT( SDL_Surface *image );
	SAT( int w, int h, rgb* image );
	~SAT();

	void update( rgb* image );
	void blur( int radius, void *dst ) const;
	void blur( int radius, SDL_Surface *dst ) const;

	rgb rect( int x1, int y1, int x2, int y2 ) const;

	int getWidth() const { return width; };
	int getHeight() const { return height; };

private:
	rgb _rect( int x1, int y1, int x2, int y2 ) const;

	int height, width;
	RGB32 *data;

};
#endif
