/********
Texture Class
*********/

#include "texture.h"
#include "util.h"

using namespace std;

pTexture::pTexture( const char* tname, const char * filename ):
name( tname ) {
	SDL_Surface *image;

	image = SDL_LoadBMP( filename );
	if( image != NULL ) {
		rgb *imgdat = new rgb[image->w*image->h];
		convtex( image, imgdat );
		glGenTextures( 1, &texname );
		glBindTexture( GL_TEXTURE_2D, texname );
		glTexImage2D( GL_TEXTURE_2D, 0, GL_RGB, image->w, image->h, 0,
			GL_RGB, GL_UNSIGNED_BYTE, imgdat );
		delete[] imgdat;
	    SDL_FreeSurface( image );
	} else {
		texname = 0;
	}
}

pTexture::~pTexture() {
	glDeleteTextures( 1, &texname );
}

const string& pTexture::getname() const {
	return name;
}

GLuint pTexture::gettex() const {
	return texname;
}
