/********
Utility functions
*********/
#include "util.h"

void convscene( SDL_Surface *image, rgb* data ) {
	rgb* ptr = data;
	for( int i = image->h-1; i >= 0; i-- ) {
		Uint8 *imgdata = (Uint8 *)image->pixels;
		imgdata += i*image->pitch;
		for( int j = 0; j < image->w; j++ ) {
			SDL_GetRGB( *(Uint32*)imgdata, image->format, &(*ptr).r, &(*ptr).g, &(*ptr).b );
			ptr++;
			imgdata += image->format->BytesPerPixel;
		}
	}
}

void convrgb( SDL_Surface *image, rgb* data ) {
	SDL_LockSurface( image );
	rgb* ptr = data;
	for( int i = image->h-1; i >= 0; i-- ) {
		Uint8 *imgdata = (Uint8 *)image->pixels;
		imgdata += i*image->pitch;
		for( int j = 0; j < image->w; j++ ) {
			Uint32 pixel = SDL_MapRGB( image->format, (*ptr).r, (*ptr).g, (*ptr).b );
			if(SDL_BYTEORDER == SDL_BIG_ENDIAN) {
				imgdata[0] = (pixel >> 16) & 0xff;
				imgdata[1] = (pixel >> 8) & 0xff;
				imgdata[2] = pixel & 0xff;
			} else {
				imgdata[0] = pixel & 0xff;
				imgdata[1] = (pixel >> 8) & 0xff;
				imgdata[2] = (pixel >> 16) & 0xff;
			}
			imgdata += image->format->BytesPerPixel;
			ptr++;
		}
	}
	SDL_UnlockSurface( image );
}


void convalpha( SDL_Surface *image, Uint8* data ) {
	Uint8* ptr = data;
	for( int i = 0; i < image->h; i++ ) {
		Uint8 *imgdata = (Uint8 *)image->pixels;
		imgdata += i*image->pitch;
		for( int j = 0; j < image->w; j++ ) {
			//*ptr = 255;
			//ptr++;
			*ptr = *imgdata;
			ptr++;
			imgdata += image->format->BytesPerPixel;
		}
	}
}

void convtex( SDL_Surface *image, rgb* data ) {
	rgb* ptr = data;
	for( int i = 0; i < image->h; i++ ) {
		Uint8 *imgdata = (Uint8 *)image->pixels;
		imgdata += i*image->pitch;
		for( int j = 0; j < image->w; j++ ) {
			SDL_GetRGB( *(Uint32*)imgdata, image->format, &(*ptr).r, &(*ptr).g, &(*ptr).b );
			ptr++;
			imgdata += image->format->BytesPerPixel;
		}
	}
}
