#ifndef __UTIL_H__
#define __UTIL_H__

//#define GL_GLEXT_PROTOTYPES 1

#include <SDL/SDL.h>
#ifdef _WIN32
#include <windows.h>
#endif
#include <GL/gl.h>
#include <GL/glu.h>
#include "glATI.h"

#ifndef M_PI
#define M_PI 3.14159265358979323846
#endif

#define deg2rad(d) ((d)*M_PI/180)
typedef struct rgb {
	Uint8 r, g, b;
} RGB;
typedef struct rgba {
	Uint8 r, g, b, a;
} RGBA;
typedef struct rgb32 {
	Uint32 r, g, b;
} RGB32;
typedef struct rgbs16 {
	short r, g, b;
} RGBS16;

const RGB RGB_0 = { 0, 0, 0 };

const int particlelist = 20;
extern GLuint particletex;
extern bool ModeDemo;
extern int MDstageprev;
extern int MDstage;

void convscene( SDL_Surface *image, rgb* data );
void convrgb( SDL_Surface *image, rgb* data );
void convalpha( SDL_Surface *image, Uint8* data );
void convtex( SDL_Surface *image, rgb* data );
void getcanvas( rgba*c, int r );

#endif
